From f425be782adbac25e49620933386968241ab3b32 Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: Jun 16 2019 06:05:35 +0000
Subject: [PATCH 3/10] add language, region and territory name from cldr


---

diff --git a/build_stats.py b/build_stats.py
index 2a7ddd9..d00fd0d 100755
--- a/build_stats.py
+++ b/build_stats.py
@@ -65,8 +65,15 @@ def parse(concat):
     data = clean_bcp47(data)
     info(data, "bcp47 data are cleaned")
 
+    data = add_cldr(data)
+    info(data, "cldr data are added")
+
+    data = clean_cldr(data)
+    info(data, "cldr data are cleaned")
+
     store(data, "3.result.csv")
 
+
 def clean_0_basic(data):
     """String cleaning and drops useless 'review' columns"""
 
@@ -143,7 +150,8 @@ def guess_bcp47(data):
     info(data, "* remove if lang endswith encoding values")
 
     # these are just re-encoded translations
-    store(data[data.lang.str.contains(".", regex=False)], '0.error.lang with point.csv')
+    store(data[data.lang.str.contains(".", regex=False)],
+          '0.error.lang with point.csv')
     data = data[~(data.lang.str.contains(".", regex=False))]
     info(data, "* remove if lang contains a point")
 
@@ -163,6 +171,7 @@ def guess_bcp47(data):
 
     return data
 
+
 def clean_bcp47(data):
     """Remove impossible values for language and region"""
     # remove region longer than 2 chars
@@ -176,12 +185,61 @@ def clean_bcp47(data):
     info(data, "* remove if len(language)>3")
 
     # remove numeric languages
-    store(data[data.language.str.isdigit()], '0.error.languages is numeric.csv')
+    store(data[data.language.str.isdigit()],
+          '0.error.languages is numeric.csv')
     data = data[~(data.language.str.isdigit())]
     info(data, "* remove if language.isdigit()")
 
+    # set types
+    data.region = data.region.fillna('')
+    data.script = data.script.fillna('')
+    data = data.astype({'region': 'str', 'language': 'str', 'script': 'str'})
+
+    return data
+
+
+def add_cldr(data):
+    """Load cldr data, merge it with"""
+    cldr_language = pandas.read_csv("CLDR-raw/language.csv")
+    cldr_language.name = cldr_language.name.str.lower()
+
+    cldr_script = pandas.read_csv("CLDR-raw/script.csv")
+    cldr_script.code = cldr_script.code.str.lower()
+    cldr_script.name = cldr_script.name.str.lower()
+
+    cldr_territory = pandas.read_csv("CLDR-raw/territory.csv")
+    cldr_territory.code = cldr_territory.code.str.lower()
+    cldr_territory.name = cldr_territory.name.str.lower()
+
+    data = data.merge(cldr_language, how='left',
+                      left_on='language', right_on='code')
+    data = data.rename(columns={'name': 'language_name'})
+    data = data.drop('code', 1)
+
+    data = data.merge(cldr_script, how='left', left_on='script',
+                      right_on='code', suffixes=(False, 'script_'))
+    data = data.rename(columns={'name': 'script_name'})
+    data = data.drop('code', 1)
+
+    data = data.merge(cldr_territory, how='left', left_on='region',
+                      right_on='code', suffixes=(False, 'territory_'))
+    data = data.rename(columns={'name': 'territory_name'})
+    data = data.drop('code', 1)
+
+    return data
+
+
+def clean_cldr(data):
+    """Remove """
+    # remove numeric languages
+    store(data[data.language_name.isnull()].drop_duplicates(
+        'language'), '0.error.language not in cldr.csv')
+    data = data[~(data.language_name.isnull())]
+    info(data, "* remove languages non existing in CLDR")
+
     return data
 
+
 def info(dataset, step):
     """Print basic informations about current dataset"""
     print(" * "+step+" → we now have "+str(len(dataset))+" rows")

